﻿#SingleInstance Force
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 작성자 : DDART
;; 배포장소 : 뽐뿌사이트 재테크포럼
;; http://www.ppomppu.co.kr/zboard/view.php?id=money&no=314829
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
global _version := "2.15"
global _app := new CAutocoderApplication("해피머니/북앤라이프/컬쳐랜드 상품권번호 자동입력기 v2.15 (2020.02.08)")
return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Gui Event 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SettingGuiClose()
{
	return _app.OnSettingClose()
}
GuiSize(hwnd, e, w, h)
{
	_app.OnSize(w, h)
}
GuiClose(hwnd)
{
	if (_app.OnClose())
	{
		return true
	}
	ExitApp
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main program
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutocoderApplication extends CWindow
{
	__New(titletext)
	{
		FileEncoding, UTF-8
		this.titletext := titletext
		this.LoadSetting()
		; GUI
		Gui, +Resize     +HWNDhWnd
		Gui, Add, Edit,   HWNDhWndContent w300 h300
		Gui, Add, Edit,   HWNDhWndLog w300 h300 hidden readonly
		Gui, Add, Button, HWNDhWndSetting, 설 정
		Gui, Add, Button, HWNDhWndChrome hidden, 크롬띄우기
		Gui, Add, Button, HWNDhWndExecute, 실 행
		Gui, Add, Button, HWNDhWndPaste, 붙여넣기
		Gui, Add, Button, HWNDhWndErase, 모두지우기
		Gui, Add, Button, HWNDhWndPrev hidden, << 이전
		Gui, Add, Button, HWNDhWndNext hidden, 다음 >>
		base.__New(hWnd)
		this.dlgSetting := new CSettingDialog(this.setting)
		; control의 id는 add 순서대로 자동부여되는데 현 구성은 3부터 부여됨.
		this.editContent := new CEditCtrl(hWndContent, 3)
		this.editLog := new CEditCtrl(hWndLog, 4)
		this.btnSetting := new CControl(hWndSetting, 5)
		this.btnChromeLaunch := new CControl(hWndChrome, 6)
		this.btnExecute := new CControl(hWndExecute, 7)
		this.btnPaste := new CControl(hWndPaste, 8)
		this.btnErase := new CControl(hWndErase, 9)
		this.btnPrev := new CControl(hWndPrev, 10)
		this.btnNext := new CControl(hWndNext, 11)
		; Init
		this.bContentInit := false
		this.bLogInit := false
		this.SetInitMessage()
		this.chrome := new CChrome()
		this.giftcard := ""
		; 윈도우메세지핸들러
		this.fnOnKeyDown := this.OnKeyDown.Bind(this)
		this.fnOnLButtonDown := this.OnLButtonDown.Bind(this)
		this.fnOnSettingChanged := this.OnSettingChanged.Bind(this)
		this.fnOnCommand := this.OnCommand.Bind(this)
		this.fnOnWebSocketDisconnected := this.OnWebSocketDisconnected.Bind(this)
		this.WM_SETTING_CHANGED := 0x10000 + 1
		this.WM_WEBSOCKET_DISCONNECTED := 0x10000+ 2
		OnMessage(0x0100, this.fnOnKeyDown)
		OnMessage(0x0201, this.fnOnLButtonDown)
		OnMessage(0x0111, this.fnOnCommand)
		OnMessage(this.WM_SETTING_CHANGED, this.fnOnSettingChanged)
		OnMessage(this.WM_WEBSOCKET_DISCONNECTED, this.fnOnWebSocketDisconnected)
		; 타이머
		this.fnResizeOnce := this.ResizeOnce.Bind(this)
		timer := this.fnResizeOnce
		SetTimer, % timer, 300
		; 기타
		this.fnOnError := this.OnError.Bind(this)
		OnError(this.fnOnError)
		this.btnPaste.ControlFocus()
		this.MakeExe()
		; 마지막
		this.Show()
		this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
	}
	AppendLog(msg)
	{
		FormatTime, TimeString, , HH:mm:ss
		msg := "[" TimeString "] " msg "`r`n"
		this.editLog.AppendText(msg)
	}
	DeleteGiftCard()
	{
		critical, On
		if (this.giftcard)
		{
			this.giftcard := ""
			this.AppendLog("추출된 상품권번호정보가 초기화되었습니다")
			this.UpdateButtons()
		}
		critical, Off
	}
	GenerateGiftCard()
	{
		if (this.giftcard)
		{
			this.AppendLog("기존 추출 정보 재사용")
			return true
		}
		
		content := this.editContent.ControlGetText()
		if (this.bContentInit && StrLen(content) > 1)
		{
			if (RegExMatch(content, "해피머니"))
			{
				this.giftcard := this.setting.browser ? new CHappyMoneyCR() : new CHappyMoneyIE()
			}
			else if (RegExMatch(content, "북앤라이프|도서문화상품권"))
			{
				this.giftcard := this.setting.browser ? new CBookNLifeCR() : new CBookNLifeIE()
			}
			else if (RegExMatch(content, "컬쳐랜드"))
			{
				this.giftcard := this.setting.browser ? new CCultureLandCR() : new CCultureLandIE()
			}
			else
			{
				this.AppendLog("상품권 종류를 알 수 없습니다. 핀번호외에 상품권명도 내용에 들어가야합니다.")
				return false
			}
			if (this.giftcard.Parse(content))
			{
				this.SaveGiftCard()
				this.UpdateButtons()
				return true
			}
			this.AppendLog(this.giftcard.GetError())
			this.giftcard := ""
			return false
		}
		this.AppendLog("상단에 내용을 입력하세요.")
		return false
	}
	InitContent()
	{
		if (!this.bContentInit)
		{
			this.editContent.Clear()
			this.bContentInit := true
		}
		this.editContent.ControlFocus()
	}
	InitLog()
	{
		if (!this.bLogInit)
		{
			this.bLogInit:= true
			this.editLog.Control("", "Show")
			this.ResizeOnce()
		}
	}
	LoadSetting()
	{
		this.setting := new CSetting()
		this.setting_file := A_ScriptDir "\\" SubStr(A_ScriptName, 1, StrLen(A_ScriptName) - 4) ".setting.json"
		if (FileExist(this.setting_file))
		{
			FileRead, str, % this.setting_file
			setting := JSON.Load(str)
			for key, val in % this.setting
			{
				this.setting[key] := setting[key] + 0
			}
			this.setting.width := Max(100, this.setting.width)
			this.setting.height := Max(100, this.setting.height)
		}
	}
	MakeExe()
	{
		name := StrReplace(A_ScriptName, ".ahk")
		compiler := StrReplace(A_AhkPath, "AutoHotkey.exe") "Compiler\Ahk2Exe.exe"
		portable := "휴대용"
		file := portable "\" name ".v" _version ".exe"
		if (InStr(A_ScriptName, ".exe") || FileExist(file) || !FileExist(name ".ico") || !FileExist(compiler))
		{
			return
		}
		if (!FileExist(portable))
		{
			FileCreateDir, %portable%
		}
		RunWait, "%compiler%" /in "%A_ScriptDir%\%name%.ahk" /out  "%A_ScriptDir%\%file%" /icon "%A_ScriptDir%\%name%.ico"
	}
	ResizeOnce()
	{
		timer := this.fnResizeOnce
		SetTimer, % timer, Off
		w := this.w 
		h := this.h
		if (!w || !h)
		{
			return
		}
		this.setting.width := w
		this.setting.height := h
		
		margin := 5
		bth := 40
		bty := margin + h - bth
		bw := 80
		bh := 25
		mh := h - bth
		cw := w - margin * 2
		ch := (this.bLogInit ? mh / 2 : mh) - margin
		lw := cw
		lh := mh / 2 - margin
		SetWinDelay, -1
		;아래쪽 컨트롤부터 옮겨야 순간 겹쳐졌던 영역이 페인트 안되는 문제를 방지할수 있다.
		this.btnSetting.Move(margin, bty, bw, bh)
		this.btnChromeLaunch.Move(margin + margin + bw, bty, bw, bh)
		this.btnExecute.Move(w - (margin + bw), bty, bw, bh)
		this.btnPaste.Move(w - (margin + bw) * 2, bty, bw, bh)
		this.btnErase.Move(w - (margin + bw) * 3, bty, bw, bh)
		this.btnNext.Move(w - (margin + bw) * 4, bty, bw, bh)
		this.btnPrev.Move(w - (margin + bw) * 5, bty, bw, bh)
		this.editLog.Move(margin, margin + (mh / 2), lw, lh)
		this.editContent.Move(margin, margin, cw, ch)
	}
	SaveGiftCard()
	{
		name := this.giftcard.name
		if (this.giftcard.exchange)
		{
			name .= "." this.giftcard.issued_company
		}
		str := this.giftcard.GetCodeInfo()
		this.AppendLog(str)
		if (!FileExist("log"))
		{
			FileCreateDir, log
		}
		last := ""
		Loop, Files, log\%name%.*.txt
		{
			last := A_LoopFilePath
		}
		if (last)
		{
			FileRead, laststr, %last%
			if (str = laststr)
			{
				return
			}
		}
		FormatTime, TimeString, , yyyyMMdd.HHmmss
		file := "log\" name "." TimeString ".txt"
		FileAppend, %str%, %file%, UTF-8
		this.AppendLog(A_ScriptDir "\" file " 에 새로운 추출정보가 저장되었습니다")
	}
	SaveSetting()
	{
		if (FileExist(this.setting_file))
		{
			FileDelete, % this.setting_file
		}
		FileAppend, % JSON.Dump(this.setting), % this.setting_file, UTF-8
	}
	SetInitMessage()
	{
		file := A_ScriptDir "\\readme.txt"
		if (FileExist(file))
		{
			FileRead, str, %file%
			this.editContent.AppendText(str)
		}
	}
	Show()
	{
		this.w := this.setting.width
		this.h := this.setting.height
		size := "w" this.w " h" this.h
		Gui, 1:Show, %size%, % this.titletext
		this.ResizeOnce()
	}
	UpdateButtons()
	{
		this.btnExecute.Control("", (this.bContentInit && this.editContent.GetWindowTextLength() > 0) ? "Enable" : "Disable")
		this.btnPrev.Control("",(this.giftcard && this.giftcard.page != 1) ? "Show" : "Hide")
		this.btnNext.Control("",(this.giftcard && this.giftcard.page != this.giftcard.total_page) ? "Show" : "Hide")
		this.btnChromeLaunch.Control("", (this.setting.browser = 1) ? "Show" : "Hide")
	}
	OnChromeLaunch()
	{
		this.chrome.Launch(this.setting.chrome_debugging_port)
	}
	OnClose()
	{
		; comobj release
		if (this.giftcard)
		{
			this.DeleteGiftCard()
			WM_CLOSE := 0x10
			this.PostMessage(WM_CLOSE, 0, 0)
			return true
		}
		this.SaveSetting()
	}
	OnCommand(wParam, lParam, nMsg, hWnd)
	{
		id := wParam & 0xFFFF
		notification_code := wParam >> 16
		if (id = this.editContent.id )
		{
			EN_CHANGE := 0x0300
			if (notification_code = EN_CHANGE)
			{
				this.DeleteGiftCard()
				if (this.bContentInit && this.editContent.GetWindowTextLength() > 0 && this.btnExecute.ControlGet("", "Enabled"))
				{
				}
				else
				{
					this.UpdateButtons()
				}
			}
		}
		else if (id = this.editLog.id)
		{
		}
		else if (id = this.btnExecute.id)
		{
			this.OnExecute()
		}
		else if (id = this.btnErase.id)
		{
			this.OnErase()
			this.UpdateButtons()
		}
		else if (id = this.btnPaste.id)
		{
			this.OnPaste()
			this.UpdateButtons()
		}
		else if (id = this.btnChromeLaunch.id)
		{
			this.OnChromeLaunch()
		}
		else if (id =  this.btnSetting.id)
		{
			this.OnSettingOpen()
		}
		else if (id = this.btnPrev.id)
		{
			this.OnPrev()
			this.UpdateButtons()
			this.btnExecute.ControlFocus()
		}
		else if (id = this.btnNext.id)
		{
			this.OnNext()
			this.UpdateButtons()
			this.btnExecute.ControlFocus()
		}
		else
		{
		}
	}
	OnErase()
	{
		this.InitContent()
		this.editLog.Clear()
		this.editContent.Clear()
		this.DeleteGiftCard()
	}
	OnError(error)
	{

		this.AppendLog("오류발생 : " error.File " " error.Line "번째줄")
		this.AppendLog(error.Extra " : " error.Message)
		this.btnExecute.Control("", "Enable")
		return true
	}
	OnExecute()
	{
		this.btnExecute.Control("", "Disable")
		this.InitLog()
		this.AppendLog("_____________________________________________________________________________________<상품권번호 추출>______")
		if (this.GenerateGiftCard())
		{
			this.AppendLog("_____________________________________________________________________________________<입력페이지 찾기>______")
			if (this.giftcard.InitWebBrowser())
			{
				this.AppendLog(this.giftcard.GetBrowserInfo())
				this.AppendLog(this.giftcard.GetCurrentPageInfo())
				this.AppendLog("_____________________________________________________________________________________<자동입력기 시작>______")
				if (this.giftcard.AutoInputEx())
				{
					this.AppendLog("_____________________________________________________________________________________<자동입력기 완료>______")
					this.OnNext()
				}
				else
				{
					this.AppendLog("_____________________________________________________________________________________<자동입력기 중단>______")
					this.AppendLog(this.giftcard.GetError())
				}
			}
			else
			{
				this.AppendLog(this.giftcard.GetError())
			}
		}
		this.btnExecute.Control("", "Enable")
		this.btnExecute.ControlFocus()
	}
	OnKeyDown(wParam, lParam, nMsg, hWnd)
	{
		if (hWnd = this.dlgSetting.hWndIE)
		{
			; AxIE에 일부 키 전달안되는 문제. TAB=9, ENTER=13, DELETE=46
			if (wParam = 9 || wParam = 13 || wParam = 46)
			{
				VarSetCapacity(msg, 7*A_PtrSize)
				for i,val in [hWnd, nMsg, wParam, lParam, A_EventInfo, A_GuiX, A_GuiY]
					NumPut(val, msg, (i-1)*A_PtrSize)
				this.dlgSetting.AxTranslateAccelerator(&msg)
				; 메세지 루프탈출
				return 0 
			}
		}
	}
	OnLButtonDown(wParam, lParam, nMsg, hWnd)
	{
		if (hWnd = this.editContent.hwnd)
		{
			this.InitContent()
			;return 0
		}
	}
	OnNext()
	{
		if (this.giftcard)
		{
			this.giftcard.SetPage(this.giftcard.page + 1)
			this.AppendLog(this.giftcard.GetCurrentPageInfo())
			this.UpdateButtons()
		}
	}
	OnPaste()
	{
		this.InitContent()
		this.editContent.AppendText(Clipboard)
		this.DeleteGiftCard()
	}
	OnSettingChanged(wParam, lParam, nMsg, hWnd)
	{
		if (this.dlgSetting.ie.beforeIE9 && this.setting.browser = 0)
		{
			this.setting.browser := 1
			this.InitLog()
			this.AppendLog("IE9 미만 시스템이어서 자동으로 크롬전용으로 전환합니다.")
			this.AppendLog("브라우저 정보 : " this.dlgSetting.ie.navigator.userAgent)
		}
		if (this.giftcard && this.giftcard.browser != this.setting.browser)
		{
			this.DeleteGiftCard()
		}
		this.giftcard.SetPage(1)
		this.AppendLog(this.giftcard.GetCurrentPageInfo())
		
		SetKeyDelay, % this.setting.key_delay
		this.UpdateButtons()
		this.Show()
	}
	OnSettingClose()
	{
		if (this.dlgSetting.OnClose())
		{
			if (this.dlgSetting.bApply)
			{
				this.setting := this.dlgSetting.setting
				this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
			}
		}
		else
		{
			; hide 시키지 않기위해
			return true
		}
		return false
	}
	OnSettingOpen()
	{
		this.dlgSetting.OnOpen(this.setting)
	}
	OnSize(w, h)
	{
		this.w := w
		this.h := h
		timer := this.fnResizeOnce
		SetTimer, % timer, Off
		SetTimer, % timer, On
	}
	OnPrev()
	{
		if (this.giftcard)
		{
			this.giftcard.SetPage(this.giftcard.page - 1)
			this.AppendLog(this.giftcard.GetCurrentPageInfo())
		}
	}
	OnWebSocketDisconnected()
	{
		this.AppendLog("크롬과의 연결이 끊어졌습니다. 다시 연결하려면 실행버튼을 누르세요.")
		this.DeleteGiftCard()
	}
}
class CWindow
{
	__New(hwnd)
	{
		this.hwnd := hwnd
		this.title := "ahk_id " this.hwnd
	}
	Activate()
	{
		WinActivate, % this.title
	}
	Exist()
	{
		return WinExist(this.title)
	}
	GetTitle()
	{
		WinGetTitle, var, % this.title
		return var
	}
	Move(x, y, w := "", h := "")
	{
		WinMove, % this.title, , x, y, w, h
	}
	Control(name, subcmd, value :="")
	{
		Control, %subcmd%, %value%, %name%, % this.title
	}
	ControlFocus(name := "")
	{
		ControlFocus, %name%, % this.title
	}
	ControlGet(name, subcmd := "hwnd", value := "")
	{
		ControlGet, outvar, %subcmd%, %value%, %name%, % this.title
		return outvar
	}
	ControlGetText(name = "")
	{
		ControlGetText, text, %name%, % this.title
		return text
	}
	ControlSend(name, keys)
	{
		ControlSend, %name%, %keys%, % this.title
	}
	ControlSetText(name, txt)
	{
		ControlSetText, %name%, %txt%, % this.title
	}
	SendMessage(msg, wParam, lParam, timeout := 5000)
	{
		SendMessage, %msg%, %wParam%, %lParam%, , % this.title, , , , %timeout%
	}
	PostMessage(msg, wParam, lParam)
	{
		PostMessage, %msg%, %wParam%, %lParam%, , % this.title
	}
	GetWindowTextLength()
	{
		WM_GETTEXTLENGTH := 0x0E
		this.SendMessage(WM_GETTEXTLENGTH, 0, 0)
		return ErrorLevel
	}
}
class CControl extends CWindow
{
	__New(hwnd, id)
	{
		base.__New(hwnd)
		this.id := id
	}
}
class CEditCtrl extends CControl
{
	Clear()
	{
		this.SetSel(0, -1)
		text := ""
		this.ReplaceSel(text)
	}
	SetSel(nStartChar, nEndChar)
	{
		EM_SETSEL := 0xB1
		this.SendMessage(EM_SETSEL, nStartChar, nEndChar)
	}
	ReplaceSel(ByRef text, bCanUndo := false)
	{
		EM_REPLACESEL := 0xC2
		this.SendMessage(EM_REPLACESEL, bCanUndo, &text)
	}
	InsertText(nInsertAfterChar, ByRef text, bCanUndo := false)
	{
		this.SetSel(nInsertAfterChar, nInsertAfterChar)
		this.ReplaceSel(text, bCanUndo)
		return ErrorLevel
	}	
	AppendText(ByRef text, bCanUndo :=false)
	{
		this.InsertText(this.GetWindowTextLength(), text, bCanUndo)
	}
	GetLimitText()
	{
		EM_GETLIMITTEXT := 0x00D5
		this.SendMessage(EM_GETLIMITTEXT, 0, 0)
		return ErrorLevel
	}
	SetLimitText(nMax)
	{
		EM_SETLIMITTEXT := 0x00C5
		this.SendMessage(EM_SETLIMITTEXT, nMax, 0)
	}
	
}
class CSetting
{
	__New()
	{
		this.width := 800
		this.height := 900
		this.browser := 0
		this.chrome_debugging_port := 9222
		this.key_delay := 50
		this.send_interval := 100
		this.ex_charging_interval := 500
		this.ex_charging_auto := 1
		this.ex_charging_target := 0
	}
}
class CSettingDialog extends CWindow
{
	
	__New(setting)
	{
		this.setting := setting
		html =
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
body { font-size:12px; margin:0px; overflow:hidden;background-color:#F0F0F0}
table{width:300px;height:300px;}
.setting td:nth-child(1) {font-size:12px; width: 100px; text-align: right}
.setting td:nth-child(2) {font-size:12px; padding-left:20px}
.setting input[type=checkbox] { border : 1px solid black; }
.setting input[type=text] { border : 1px solid black; width:60px; text-align:right; }
.setting input[type=button] {font-size:12px; border : 1px solid #ADADAD; background-color:#E1E1E1;width:80px;height:25px; }
td.bottom{align:right; padding-right:20px}
</style>
<script>
var setting = null;
var proptype_checkbox = {"browser" : true, "ex_charging_auto" : true, "ex_charging_target" : true};
var beforeIE9 = document.getElementsByClassName ? false : true;
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function StrUnescape(str)
{
	return unescape(str)
}
function Init(data)
{
	if (data)
	{
		setting = JSON.parse(data);
	}
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				elms[i].checked = (i == setting[prop]);
				elms[i].addEventListener("click", OnClickCheckbox)
			}
		}
		else
		{
			var elm = document.getElementById(prop);
			if (elm)
			{
				elm.value = setting[prop];
			}		
		}	
	}
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
	document.getElementById("chrome_display").style.display = (setting.browser == 0) ? "none" : "";	
	document.getElementsByClassName("exchange_display")[0].style.display = (setting.ex_charging_auto == 0) ? "none" : "";	
	document.getElementsByClassName("exchange_display")[1].style.display = (setting.ex_charging_auto == 0) ? "none" : "";	
}
function Submit()
{
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				if  (elms[i].checked)
				{
					setting[prop] = i;
					break;
				}
			}
			
		}
		else
		{
			var elm = document.getElementById(prop)
			if (elm)
			{
				setting[prop] = parseInt(elm.value);
			}
		}
	}
	return JSON.stringify(setting);
}
function OnClickCheckbox(e)
{
	var elms = document.getElementsByClassName(e.srcElement.className);
	for (var i=0; i < elms.length; i++)
	{
		if (elms[i] == e.srcElement)
		{
			if (elms[i].className == "browser")
			{
				document.getElementById("chrome_display").style.display = (i == 0) ? "none" : "";	
			}
			else if (elms[i].className == "ex_charging_auto")
			{
				document.getElementsByClassName("exchange_display")[0].style.display = (i == 0) ? "none" : "";	
				document.getElementsByClassName("exchange_display")[1].style.display = (i == 0) ? "none" : "";	
			}
		}
		else
		{
			elms[i].checked = false;
		}
	}
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td>브라우저</td>
	<td> <input type=checkbox class=browser> 익스플로러 <input type=checkbox class=browser>크롬</td>
  </tr>
  <tr id=chrome_display>
    <td>크롬디버거포트</td>
	<td> <input type=text maxlength=5 id=chrome_debugging_port> (default: 9222)</td>
  </tr>
  <tr>
    <td>키사이 지연</td>
	<td> <input type=text maxlength=3 id=key_delay> msec (10~999)</td>
  </tr>
  <tr>
    <td>칸사이 지연</td>
	<td> <input type=text maxlength=3 id=send_interval> msec (0~999)</td>
  </tr>
  <tr>
    <td>교환권 충전방식</td>
	<td> <input type=checkbox class=ex_charging_auto> 수동 <input type=checkbox class=ex_charging_auto> 자동</td> 
  </tr>
  <tr class=exchange_display>
    <td>교환권 충전대상</td>
	<td> <input type=checkbox class=ex_charging_target> 캐시 <input type=checkbox class=ex_charging_target> 핀번호</td> 
  </tr>
  <tr class=exchange_display>
    <td>교환권사이 지연</td>
	<td> <input type=text maxlength=4 id=ex_charging_interval> msec (0~9999)</td>
  </tr>
  <tr>
	<td colspan=2 class=bottom> 
	   <input type=hidden maxlength=4 id=width>
	   <input type=hidden maxlength=4 id=height>
	   <input type=button class=button value="취 소">&nbsp; 
	   <input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)		
		; 윈도우7 이상에서는 IE11 버전의 ActiveX IE가 호스팅되도록해줌. 이 키값이 없으면 호스팅시 메타태그로 버전 선택이 안되고, 제일 구버전 IE7 호환모드로 호스팅됨
		if (!InStr(A_OSVersion, "WIN_") || SubStr(A_OSVersion, 5, 1) >= 7)
		{
            be := {"Default" : 0, "IE7" : 7000, "IE8" : 8000, "IE8STD" : 8888, "IE9" : 9000, "IE9STD" : 9999, "IE10" :10000, "IE10STD" : 10001, "IE11" : 11000, "IE11Edge" : 11001}
			emulation := be.IE11Edge
			RegRead, emul_current, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe
			if (emul_current != emulation)
			{
				RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe, %emulation%
			}
		}
		static wb
		Gui, Setting:+Owner1 +hWndhWnd -Resize -MaximizeBox -MinimizeBox
		Gui, Setting:Add, ActiveX, vwb hWndhWndAX x0 y0 w300 h300, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		base.__New(hWnd)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()
		winAX := new CWindow(hWndAX)
		this.hWndIE := winAX.ControlGet("Internet Explorer_Server1")
		this.pipa := ComObjQuery(wb, "{00000117-0000-0000-C000-000000000046}")
		this.pfnTranslateAccelerator := NumGet(NumGet(1*this.pipa)+5*A_PtrSize)
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
	}
	__Delete()
	{
		ObjRelease(this.pipa)
		this.ie := ""
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	AxTranslateAccelerator(pMsg)
	{
		DllCall(this.pfnTranslateAccelerator, "Ptr", this.pipa, "Ptr", pMsg)
	}
	ApplyChange()
	{
		data := this.ie.Submit()
		setting := JSON.Load(data)
		err := ""
		if (setting.width < 100 || setting.width > A_ScreenWidth)
		{
			err .= "창크기 가로는 100 보다 크거나 " A_ScreenWidth " 보다 작아야 합니다. "
		}
		if (setting.height < 100 || setting.height > A_ScreenHeight)
		{
			err .= "창크기 세로는 100 보다 크거나 " A_ScreenHeight " 보다 작아야 합니다. "
		}
		if (setting.chrome_debugging_port < 1024 || setting.chrome_debuggin_port > 65535)
		{
			err .= "디버거포트는 1024 ~ 65535 범위내에서만 설정가능합니다."
		}
		if (err)
		{
			MsgBox, 0x10, 입력오류, %err%
			return false
		}
		this.setting := setting
		return true
	}
	OnClick(e)
	{
		if (e.srcElement.type = "button")
		{
			if (e.srcElement.value = "확 인")
			{
				if (!this.ApplyChange())
				{
					return
				}
			}
			else
			{
				this.bApply := false
			}
			WM_CLOSE := 0x10
			this.PostMessage(WM_CLOSE, 0, 0)
		}
	}
	OnClose()
	{
		if (this.bApply && !this.ApplyChange())
		{
			return false
		}
		Gui, 1:-Disabled
		Gui, Hide
		return true
	}
	StrUnescape(str)
	{
		return this.ie.StrUnescape(str)
	}
	OnOpen(setting)
	{
		if (this.ie.beforeIE9)
		{
			MsgBox, , 설정오류, 시스템에 Internet Explorer 9 버전 이상이 필요합니다
			return
		}
		this.setting := setting
		this.ie.Init(JSON.Dump(setting))
		this.bApply := true
		Gui, +Disabled
		Gui, Setting:Show, w300 h300, 설정
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CModalDialog extends CWindow
{
	__New(html, w, h, title := "")
	{
		static wb
		Gui, popup:+Owner1 +hWndhWnd -Resize -MaximizeBox -MinimizeBox
		Gui, popup:Add, ActiveX, vwb hWndhWndAX x0 y0 w%w% h%h%, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		base.__New(hWnd)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()		
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		Gui, 1:+Disabled
		Gui, popup:Show, , %title%
		this.clicked_button := 0
		this.ID_CANCEL := 0
		this.ID_OK := 1
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	OnClick(e)
	{
		if (e.srcElement.type = "button")
		{
			if (e.srcElement.value = "확 인")
			{
				if (!this.ApplyChange())
				{
					return
				}
				this.clicked_button := this.ID_OK
			}
			else
			{
				this.clicked_button := this.ID_CANCEL
			}
			WM_CLOSE := 0x10
			this.PostMessage(WM_CLOSE, 0, 0)
		}
	}
	ApplyChnage()
	{
		return false
	}
	DoModal()
	{
		WinWaitClose, % this.title
		Gui, 1:Show
		Gui, 1:-Disabled
		Gui, popup:Hide
		Gui, popup:Destroy
		return this.clicked_button
	}
}
class CExchangeInfoDialog extends CModalDialog
{
	__New(g, c)
	{
		html = 
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
body { font-size:12px; margin:0px; overflow:hidden;background-color:#F0F0F0}
table{width:250px;height:200px;}
.setting select{font-size:12px; border : 1px solid black; }
.setting td:nth-child(1) {font-size:12px; width: 70px; text-align: center}
.setting td:nth-child(2) {font-size:12px; padding-left:20px}
.setting input[type=text] { border : 1px solid black; width:120px;}
.setting input[type=button] {font-size:12px; border : 1px solid #ADADAD; background-color:#E1E1E1;width:80px;height:25px; }
td.bottom{text-align:center;}
td.title{text-align:left; color:red;}
</style>
<script>
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function SelectOption(id, value)
{
	for (var i = 0; i < document.getElementById(id).options.length; i++)
	{
		if (document.getElementById(id).options[i].innerText == value)
		{
			document.getElementById(id).selectedIndex = i;
			break
		}		
	}
	document.getElementById(id).addEventListener("change", OnComboChange)
}
function Init(giftcard, issued_company,  phone_number)
{
	document.getElementById("giftcard").innerText = giftcard;
	if (issued_company)
	{
		SelectOption("issued_company", issued_company);
	}
	if (phone_number)
	{
		document.getElementById("phone_number").value = phone_number;
	}
	OnComboChange(null);
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
}
function OnComboChange(e)
{
	c = document.getElementById("issued_company").value;
	g = document.getElementById("giftcard").innerText;
	document.getElementById("phone_display").style.display = ((g == "해피머니" && c == "기프티콘") || g == "컬쳐랜드") ? "" : "none";
}
function Submit()
{
	return {
	"issued_company" : document.getElementById("issued_company").options[document.getElementById("issued_company").selectedIndex].innerText, 
	"phone_number" : document.getElementById("phone_number").value
	};
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td colspan=2 class=title> 필수정보를 찾을수 없습니다. <br>맞게 선택(입력) 해주세요.</td>
  </tr>
  <tr>
    <td>교환대상</td>
	<td><span id=giftcard></span></td>
  </tr>
  <tr>
    <td>발행회사</td>
	<td><select id=issued_company><option>기프티콘</option><option>아이넘버</option><option>기프티쇼</option><option>기프트팝</option></select></td>
  </tr>
  <tr id=phone_display>
    <td>수신번호</td>
	<td> <input type=text maxlength=11 id=phone_number></td>
  </tr>
  <tr>
	<td colspan=2 class=bottom> 
	   	   <input type=button class=button value="취 소">&nbsp;
			<input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, 250, 200, "추가정보확인")
		this.issued_company := c
		this.giftcard := g
		RegRead, phone_number , HKEY_CURRENT_USER\Software\Autocoder, PhoneNumber
		this.phone_number := phone_number
	}
	__Delete()
	{
		if (this.phone_number)
		{
			RegWrite, REG_SZ, HKEY_CURRENT_USER\Software\Autocoder, PhoneNumber, % this.phone_number
		}
	}
	DoModal()
	{
		this.ie.Init(this.giftcard, this.issued_company, this.phone_number)
		return base.DoModal()
	}
	ApplyChange()
	{
		ret := this.ie.Submit()
		this.issued_company := ret.issued_company
		if (this.giftcard = "컬쳐랜드" || (this.giftcard = "해피머니" && this.issued_company = "기프티콘"))
		{
			pn := RegExReplace(ret.phone_number, "[^\d]")
			if (StrLen(pn) != 11)
			{
				MsgBox, 0x10, 입력오류, 전화번호 길이가 맞지않습니다.
				return false
			}
			this.phone_number := pn
		}
		return true
	}
}	
class CIssuedDateDialog extends CModalDialog
{
	__New()
	{
		html = 
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
body { font-size:12px; margin:0px; overflow:hidden;background-color:#F0F0F0}
table{width:250px;height:150px;}
.setting select{font-size:12px; border : 1px solid black; }
.setting td:nth-child(1) {font-size:12px; width: 100px; text-align: center}
.setting td:nth-child(2) {font-size:12px; padding-left:20px}
.setting input[type=text] { border : 1px solid black; width:100px;}
.setting input[type=button] {font-size:12px; border : 1px solid #ADADAD; background-color:#E1E1E1;width:80px;height:25px; }
td.bottom{text-align:center;}
td.title{text-align:left; color:red;}
</style>
<script>
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function Init(issued_date)
{
	document.getElementById("issued_date").innerText = issued_date;
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
}
function Submit()
{
	return document.getElementById("issued_date").value;
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td colspan=2 class=title> 발행일자를 찾을 수 없습니다.<br> 직접 입력해주세요</td>
  </tr>
  <tr>
    <td>발행일자</td>
	<td> <input type=text maxlength=8 id=issued_date></td>
  </tr>
  <tr>
	<td colspan=2 class=bottom> 
	   	   <input type=button class=button value="취 소">&nbsp;
			<input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, 250, 150, "추가정보확인")
		RegRead, var , HKEY_CURRENT_USER\Software\Autocoder, IssuedDate
		this.issued_date := var
	}
	__Delete()
	{
		if (this.issued_date)
		{
			RegWrite, REG_SZ, HKEY_CURRENT_USER\Software\Autocoder, IssuedDate, % this.issued_date
		}
	}
	DoModal()
	{
		this.ie.Init(this.issued_date)
		return base.DoModal()
	}
	ApplyChange()
	{
		n := RegExReplace(this.ie.Submit(), "[^\d]")
		if (StrLen(n) != 8)
		{
			MsgBox, 0x10, 입력오류, 발행일자길이가 맞지않습니다.
			return false
		}
		this.issued_date := n
		return true
	}
}	







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GiftCode class
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CGiftCode
{
	codes := Object()
	__New(b, n, r, h, l, c, p := 10)
	{
		this.browser := b
		this.name := n
		this.regex := r
		this.win := b ? new CWBChrome(n, h, l, c) : new CWBInternetExplorer(n, h, l, c)
		this.npp := p
		this.npp_default := p
		this.issued_date := 0
		this.exchange := false
		this.issued_company := 0
		this.phone_number := ""
		this.exchange_urls := Object()
	}
	GetError()
	{
		err := this.err this.win.err
		this.err := ""
		this.win.err := ""
		return err
	}
	GetBrowserInfo()
	{
		return this.win.GetBrowserInfo()
	}
	GetCurrentPageInfo()
	{
		return "다음 실행될 페이지는 " this.page " / " this.total_page " 페이지입니다"	
	}
	GetCodeInfo()
	{
		code := this.name " " (this.exchange ? "교환권" : "상품권") " 총" this.codes.MaxIndex() " 개 발견`r`n`r`n"
		if (this.issued_date)
		{
			code .= "발행일 : " this.issued_date "`r`n`r`n"
		}
		if (this.issued_company)
		{
			code .= "발행사 : " this.issued_company "`r`n`r`n"
		}
		if (this.phone_number)
		{
			code .= "수신번호 : " this.phone_number "`r`n`r`n"
		}
		Loop, % this.codes.MaxIndex()
		{
			row := A_Index
			code .= this.GetRowCountPrefix(row)
			if (this.exchange)
			{
				code .= this.codes[row] "`r`n"
			}
			else
			{
				Loop, % this.codes[row].MaxIndex()
				{
					
					code .= this.codes[row][A_Index]
					
					if (A_Index = this.codes[row].MaxIndex())
					{
						code .= "`r`n"
					}
					else
					{
						code .= "-"
					}
				}
			}
		}
		return code
	}
	SetPage(page)
	{
		this.npp := (this.exchange && !_app.setting.ex_charging_auto) ? 1 : this.npp_default
		this.total_page := Ceil(this.codes.MaxIndex() / this.npp)
		if (page >= 1 && page <= this.total_page)
		{
			this.page := page
			this.page_base := (this.page - 1) * this.npp
			return true
		}
		return false
	}
	SetInputElementsError()
	{
		this.err := this.name " 입력창의 구성요소를 찾을수 없습니다. 상품권 번호 입력창이 띄워져 있는지 확인하세요"
	}
	ConfirmExchangeErrorGoNext(row)
	{
		_app.editLog.AppendText("교환에 실패했습니다. `r`n")
		if (row < this.codes.MaxIndex())
		{
			MsgBox, 4, 자동입력기, 교환권 교환에 실패했습니다. 그래도 다음번호로 계속 진행하시겠습니까?, 30
			IfMsgBox, Yes
			{
				return true
			}
			return false
		}				
		return true
	}
	GetUserInputIssuedDate()
	{
		dlg := new CIssuedDateDialog()
		if (dlg.DoModal())
		{
			_app.editContent.AppendText("`r`n`r`n발행일 : "  dlg.issued_date "`r`n")
			this.issued_date := dlg.issued_date
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}	
	GetUserInputExchangeInfo()
	{
		dlg := new CExchangeInfoDialog(this.name, this.issued_company)
		if (dlg.DoModal())
		{
			if (!this.issued_company)
			{
				_app.editContent.AppendText("`r`n`r`n발행회사 : "  dlg.issued_company "`r`n")
			}
			if (!this.phone_number && dlg.phone_number)
			{
				_app.editContent.AppendText("`r`n수신 : " dlg.phone_number "`r`n")
			}
			this.issued_company := dlg.issued_company
			this.phone_number := dlg.phone_number
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}
	GetExchangeInfo(ByRef content)
	{
		regexp := "Oi)(기프티쇼|기프티콘|기프트팝|아이넘버|giftishow|gifticon|giftpop|inumber)"
		if (RegExMatch(content, regexp, matches))
		{
			cnames_ko := ["기프티쇼", "기프티콘", "기프트팝", "아이넘버"]
			cnames_en := ["giftishow", "gifticon", "giftpop", "inumber"]
			this.issued_company := matches[1]
			Loop, % cnames_en.MaxIndex()
			{
				if (this.issued_company = cnames_en[A_Index])
				{
					this.issued_company := cnames_ko[A_Index] 
					break
				}
			}
		}
		if (RegExMatch(content, "O)수신.*(01[\d\-]{9,})", matches))
		{
			this.phone_number := SubStr(RegExReplace(matches[1], "-"), 1, 11)
		}
		if (!this.issued_company && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		if ((this.name = "컬쳐랜드" || (this.name = "해피머니" && this.issued_company = "기프티콘")) && ! this.phone_number && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		url := this.exchange_urls[this.issued_company]
		if (url)
		{
			this.win.SetChargingUrl(url)
		}
		else
		{
			this.err := this.issued_company " 의 " this.name " 교환권은 지원하지 않습니다."
			return false
		}
		return true
	}
	ParseRegex(ByRef content)
	{
		pos := 1
		while (pos := RegExMatch(content, this.regex, matches, pos))
		{
			code := ""
			Loop, % matches.Count()
			{
				code .= matches.Value(A_Index)
			}
			this.codes.Push(RegExReplace(code, "[^\d]"))
			pos += matches.Len(0)
		}
	}
	Parse(ByRef content)
	{
		this.ParseRegex(content)
		this.ArrangeCode()
		if (this.codes.MaxIndex() > 0)
		{
			if (this.name = "해피머니" && this.codes[1][5] = 0)
			{
				if (RegExMatch(content, "O)발행일[^\d]*(202[\d\_\-]{5,})", matches))
				{
					this.issued_date := RegExReplace(matches[1], "[^\d]")
					if (StrLen(this.issued_date) != 8)
					{
						this.issued_date := 0
					}
				}
				else (RegExMatch(content, "Os)발행일.*(202[\d]{5})", matches))
				{
					this.issued_date := matches[1]
				}
				if (this.issued_date || this.GetUserInputIssuedDate())
				{
					Loop, % this.codes.MaxIndex()
					{
						this.codes[A_Index][5] := this.issued_date
					}
				}
				else
				{
					return false
				}
			}
		}
		else
		{
			this.regex :=  "O)([\d\-\_ ]{12,})"
			this.ParseRegex(content)
			if (this.codes.MaxIndex() > 0)
			{
				this.exchange := this.GetExchangeInfo(content)
				if (this.exchange)
				{
					this.ArrangeExCode()
				}
				else
				{
					return false
				}
			}
		}
		if (this.codes.MaxIndex() < 1)
		{
			if (this.exchange)
			{
				this.err := this.issued_company " " this.name " 교환 쿠폰번호를 하나도 찾을수 없습니다."
			}
			else
			{
				this.err := this.name " 핀번호를 하나도 찾을수 없습니다."
			}
			return false
		}
		this.SetPage(1)
		return true
	}
	InitWebBrowser()
	{
		if (this.win.Init())
		{
			this.win.Activate()
			this.win.Move(0, 0)
			this.err := "로그인 해주세요"
			return this.win.CheckState() && this.IsLogined()
		}
		return false
	}
	GotoCharging()
	{
		this.err := ""
		if (!this.win.GotoUrl(this.win.charging_url))
		{
			this.err := "충전페이지 이동에 실패했습니다"
			return false
		}
		this.win.Activate()
		Sleep, 1000
		return true
	}
	GetRowCountPrefix(row)
	{
		max_len := StrLen(this.codes.MaxIndex())
		prefix := "0000"
		return SubStr(prefix, 1, max_len - StrLen(row)) row "/" this.codes.MaxIndex() " : "
	}
	SendExchange(row, code)
	{
		_app.editLog.AppendText(this.GetRowCountPrefix(row) code "`r`n")
		Send %code%
	}
	Send(row, col, skip := false)
	{
		if (!skip)
		{
			Sleep, % _app.setting.send_interval
			Send, % this.codes[row][col]
		}
		if (col = 1)
		{
			_app.editLog.AppendText(this.GetRowCountPrefix(row))
		}
		_app.editLog.AppendText(this.codes[row][col])
		if (col = this.codes[row].MaxIndex())
		{
			_app.editLog.AppendText("`r`n")
		}
		else
		{
			_app.editLog.AppendText("-")
		}
	}
	ArrangeExCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 12)
			{
				arr.Push(codes)
			}
		}
		this.codes := arr
	}
	ArrangeCode()
	{
	}
	IsLogined()
	{
		return false
	}
	AutoInputEx()
	{
		if (this.exchange)
		{
			Loop, % this.npp
			{
				row := A_Index + this.page_base
				code := this.codes[row]
				if (row > this.codes.MaxIndex())
				{
					break
				}
				if (this.GotoCharging())
				{
					if (_app.setting.ex_charging_interval)
					{
						_app.editLog.AppendText("계정 차단방지를 위해  " Format("{1:.2f}", _app.setting.ex_charging_interval/1000)  " 초간 쉽니다.`r`n")
						Sleep, % _app.setting.ex_charging_interval
					}
				}
				else
				{
					return false
				}
				if (this.AutoExchangeInput(row, code))
				{
					_app.editLog.AppendText(this.GetRowCountPrefix(row) code "`r`n")
				}
				else
				{
					return false
				}
			}
			return true
		}
		else
		{
			return this.GotoCharging() && this.AutoInput()
		}
	}
	AutoExchangeInput(row, code)
	{
		return false
	}
	AutoInput()
	{
		return false
	}
}
class CWebBrowser extends CWindow
{
	__New(n, h, l, c)
	{
		this.wb := ""
		this.name := n
		this.homepage_url := h
		this.login_url := h l
		this.charging_url := h c
	}
	SetChargingUrl(url)
	{
		this.charging_url :=  this.homepage_url url
	}
	SetHWnd(hwnd)
	{
		this.hwnd := hwnd
		this.title := "ahk_id " hwnd
		return WinExist(this.title)
	}
	GetDomain(url)
	{
		if (RegExMatch(url, "O)\/\/([\w\.]+)", matches))
		{
			return matches[1]
		}
		return ""
	}
}
class CWBInternetExplorer extends CWebBrowser
{
	__Delete()
	{
		this.wb := ""
	}
	GetBrowserInfo()
	{
		return this.wb.document.parentWindow.navigator.userAgent
	}
	Init()
	{
		this.err := ""
		if (!this.SetHWnd(WinExist("ahk_class IEFrame")))
		{
			this.err .= "인터넷 익스플로러가 실행중이지 않습니다`r`n"
			this.err .= "실행 후 " this.name " 로그인 페이지로 이동합니다. 로그인해주세요"
			wb := ComObjCreate("InternetExplorer.Application")
			wb.Visible := true
			wb.Navigate(this.login_url)
			ObjRelease(wb)
			return false
		}
		Loop, 3
		{
			this.Activate()
			this.wb := WBGet()
			if (this.wb)
			{
				return true
			}
			Sleep, 500
		}
		this.err := "IWebBrowserApp Com Object를 가져올 수 없습니다."
		return false
	}
	WaitComplete()
	{
		Loop, 50
		{
			Sleep, 200
			if (this.wb.document.readyState = "complete")
			{
				return true
			}
		}
		return false
	}
	GotoUrl(url)
	{
		this.Activate()
		current_url := SubStr(this.wb.document.location.href, 6)
		if (InStr(url, current_url))
		{
			this.wb.document.location.reload(false)
			return this.WaitComplete()
		}
		this.ControlSetText("Edit1", url)
		this.ControlSend("Edit1", "{Enter}")
		Sleep, 500
		this.WaitComplete()
		Loop, 10
		{
			current_url := SubStr(this.wb.document.location.href, 6)
			if (InStr(url, current_url))
			{
				return true
			}
			else
			{

				this.wb := WBGet()
			}
		}
		return false
	}
	
	CheckState()
	{
		this.err := ""
		if (!InStr(this.wb.document.location.href, this.GetDomain(this.homepage_url)))
		{
			this.err .= "활성화된 '" this.name "' 페이지를 찾을수 없습니다. `r`n"
			if (this.wb.document.title != "빈 페이지 - Internet Explorer" && this.wb.document.title != "새 탭 - Internet Explorer")
			{
				this.err .= " " this.name " 로그인 페이지로 이동합니다."
				; 새 탭 열기
				Send, ^t
				Loop, 20
				{
					Sleep, 200
					this.win := new CWindow(WinExist("ahk_class IEFrame"))
					if (this.win.GetTitle() = "새 탭 - Internet Explorer")
					{
						break
					}
					else
					{
					}
				}
			}
			if (!this.GotoUrl(this.login_url))
			{
				; WB 재설정 해줌
				this.wb := ""
				return false
			}
		}
		return true
	}
}
class CWBChrome extends CWebBrowser
{
	__Delete()
	{
		if (this.wb)
		{
			this.wb.Disconnect()
		}
		this.wb := ""
	}
	GetBrowserInfo()
	{
		result := this.wb.GetVersion()
		return result.userAgent
	}
	Init()
	{
		this.err := ""
		if (!this.SetHWnd(_app.chrome.IsExist()))
		{
			this.err := "개발자모드로 실행된 크롬창이 존재하지 않습니다. 크롬을 개발자모드로 실행합니다. `r`n"
			_app.OnChromeLaunch()
			Loop, 40
			{
				Sleep, 250
				if (this.SetHWnd(_app.chrome.IsExist()))
				{
					break
				}
			}
		}
		if (!this.Exist())
		{
			this.err .= "개발자모드로 실행된 크롬창이 존재하지 않습니다"
			return false
		}
		this.Activate()
		return true
	}
	OpenNewTab()
	{
		; 새 탭 열기
		this.wb.Disconnect()
		this.wb := ""
		Send, ^t
		Loop, 10
		{
			Sleep, 250
			url := _app.chrome.GetWebSocketUrl("새 탭")
			if (url)
			{
				break
			}
		}
		if (url)
		{
			this.wb := new CChromeWSClient(url)
		}
	}
	CheckState()
	{
		title := RegExReplace(this.GetTitle(), " - Chrome$")
		url := _app.chrome.GetWebSocketUrl(title)
		if (url = -1)
		{
			this.err := "크롬 DevTool의 /json/list 엔드포인트에 연결할수 없습니다."
			return false
		}
		else if (!url)
		{
			this.err := "현재 창에 대한 디버깅주소를 못찾음"
			return false
		}
		if (this.wb)
		{
			if (this.wb.url != url || !this.wb.bConnected)
			{
				this.wb.Disconnect()
				this.wb := new CChromeWSClient(url)
			}
		}
		else
		{
			this.wb := new CChromeWSClient(url)
		}
		result := this.wb.Evaluate("document.location.href")
		if (!InStr(result.value, this.GetDomain(this.homepage_url)))
		{
			this.err .= "활성화된 '" this.name "' 페이지를 찾을수 없습니다. `r`n"
			this.err .= " " this.name " 로그인 페이지로 이동합니다."
			if (title != "새 탭")
			{
				this.OpenNewTab()
			}
			if (!this.GotoUrl(this.login_url))
			{
				this.err .= "새탭을 못엶. 다시 실행시도해주세요"
			}
		}
		return true
	}
	GotoUrl(url)
	{
		if (!this.wb)
		{
			return false
		}
		result := this.wb.Navigate(url)
		if (result)
		{
			if (this.WaitComplete())
			{
				return true
			}
		}
		return false
	}
	WaitComplete()
	{
		Loop, 40
		{
			Sleep, 250
			result := this.wb.Evaluate("document.readyState")
			if (result && result.value = "complete")
			{
				return true
			}
		}
		return false
	}
}
class CHappyMoney extends CGiftCode
{
	__New(b)
	{
		base.__New(b, "해피머니", "O)([\d\-\_ ]{16,})", "http://www.happymoney.co.kr", "/svc/login/login.hm", "/svc/cash/giftCardCharge.hm")
		this.exchange_urls["기프티쇼"] := "/svc/card/exchangeCoupon.hm"
		this.exchange_urls["기프티콘"] := "/svc/card/exchangeCoupon.hm"
		this.exchange_urls["기프트팝"] := "/svc/card/exchangeCoupon.hm"
		this.exchange_urls["아이넘버"] := "/svc/card/exchangeCoupon.hm"
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 24)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4), SubStr(codes, 17, 8)))
			}
			else if(StrLen(codes) = 16)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4), 0))
			}
		}
		this.codes := arr
	}
}
class CBookNLife extends CGiftCode
{
	__New(b)
	{
		base.__New(b, "북앤라이프", "O)([\-\d]{16,})[^\d]*(\d{4})", "https://www.booknlife.com", "/hp/login.do", "/hp/payModule/CashChargeBnlVoucher.do", 20)
		this.exchange_urls["기프티콘"] := "/hp/payModule/couponExchangeGifticon.do"
		this.exchange_urls["카카오톡"] := "/hp/payModule/couponExchangeKakao.do"
		this.exchange_urls["기프티쇼"] := "/hp/payModule/couponExchangeGiftishow.do"
		this.exchange_urls["아이넘버"] := "/hp/payModule/couponExchangeInumber.do"
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 24)
			{
				codes := SubStr(codes, 1, 20)
			}
			if(StrLen(codes) = 20)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4), SubStr(codes, 17, 4)))
			}
		}
		this.codes := arr
	}
}
class CCultureLand extends CGiftCode
{
	__New(b)
	{
		base.__New(b, "컬쳐랜드", "O)([\d\-\_ ]{16,})", "http://www.cultureland.co.kr", "/signin/login.do", "/charge/gift/giftVoucher.do")
		; this.exchange_urls["기프티콘"] := "/purchase/exchange/couponSelect.do"
		; 카카오|구글플레이|기프티콘|아이넘버
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 18)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 6)))
			}
			else if(StrLen(codes) = 16)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4)))
			}
		}
		this.codes := arr
	}
}
class CHappyMoneyIE extends CHappyMoney
{
	__New()
	{
		base.__New(0)
	}
	IsLogined()
	{
		elm := this.win.wb.document.getElementById("myBoxSub")
		return  (elm && elm.parentElement.style.display = "")
	}
	AutoInput()
	{
		if (!this.win.wb.document.getElementById("layer_1"))
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.document.getElementById("layer_1").style.display :="none"
		Sleep, 500
		this.win.wb.document.getElementById("addTen").scrollIntoView(true)
		
		if (this.codes.MaxIndex() - this.page_base > 5 && this.win.wb.document.getElementsByClassName("delTen")[0].style.display != "inline-block")
		{
			this.win.wb.document.getElementById("addTen").click()
		}
		if (this.win.wb.document.getElementsByClassName("csOn").length = 1)
		{
			this.win.wb.document.getElementsByClassName("csOn")[0].click()
		}
		Sleep, 500
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				if (col = 5)
				{
					eid := "issuedDate_" (row - this.page_base)
				}
				else
				{
					eid := "pinNo" col "_" (row - this.page_base)
				}
				this.win.wb.document.getElementById(eid).click()
				this.Send(row, col)
			}
		}
		return true
	}
	AutoExchangeInput(row, code)
	{
		elements := this.win.wb.document.getElementsByClassName("inDetailBox")
		if (!elements || elements.length < 1)
		{
			this.SetInputElementsError()
			return false
		}
		elements := elements[0].getElementsByTagName("IMG")
		bFound := false
		Loop, % elements.length
		{
			if (elements[A_Index -1].alt = this.issued_company)
			{
				elements[A_Index - 1].click()
				bFound := true
				break
			}
		}
		if (!bFound)
		{
			this.err := "입력페이지에서 " this.issued_company " 요소를 찾을수 없습니다."
			return false
		}
		if (this.issued_company = "기프티콘")
		{
			this.win.wb.document.getElementById("phoneNo").focus()
			Send, % this.phone_number
			this.win.wb.document.getElementById("agreeThisOne").click()
		}
		this.win.wb.document.getElementById("couponNo").focus()
		this.SendExchange(row, code)
		this.win.wb.document.getElementById("couponRetrieve").click()
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}
		result_msg := this.win.wb.document.getElementsByClassName("payDetail excCoupon")[2].innerText
		if (RegExMatch(result_msg, "가능합니다"))
		{
			charge_btnclass := _app.setting.ex_charging_target ? "hpOnlin" : "hpCash"
			this.win.wb.document.getElementsByClassName(charge_btnclass)[0].getElementsByTagName("A")[0].click()
			if (RegExMatch(result_msg, "충전되었습니다|완료되었습니다"))
			{
				_app.editLog.AppendText(result_msg "`r`n")
				return true
			}
			this.err .= "교환이 완료되지 못했습니다"
			return this.ConfirmExchangeErrorGoNext(row)
		}
		else
		{
			this.err .= "확인결과가 유효하지 않습니다.."
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}
}
class CHappyMoneyCR extends CHappyMoney
{
	__New()
	{
		base.__New(1)
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("document.getElementById('myBoxSub').parentElement.style.display")
		return (result.value = "")
	}
	AutoInput()
	{
		result := this.win.wb.Evaluate("document.getElementById('addTen')")
		if (result.subtype = "null")
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.Evaluate("document.getElementById('layer_1').style.display='none'")
		this.win.wb.Evaluate("document.getElementById('addTen').scrollIntoView(true)")
		result := this.win.wb.Evaluate("document.getElementsByClassName('delTen')[0].style.display")
		if (result.value != "inline-block" && this.codes.MaxIndex() > 5)
		{
			this.win.wb.Evaluate("document.getElementById('addTen').click()")
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('csOn').length")
		if (result.value = 1)
		{
			result := this.win.wb.Evaluate("document.getElementsByClassName('csOn')[0].click()")
		}
		; 해피머니사이트의 TouchEnNxKey가 빠른입력에 심술부리는것  무력화시키기
		disable_tk := "var fn=function(id){ elm = document.getElementById(id); elm.removeEventListener('keydown', TK_KeyDown); elm.removeEventListener('keypress', TK_Keypress); elm.removeEventListener('keyup', TK_Keyup);};for (r=1; r <=10; r++){ for(c=1;c <=4;c++) {  fn('pinNo' + c + '_' + r); } fn('issuedDate_'+r);}"
		
		result := this.win.wb.Evaluate(disable_tk)
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				if (col = 5)
				{
					eid := "issuedDate_" (row - this.page_base)
				}
				else
				{
					eid := "pinNo" col "_" (row - this.page_base)
				}
				Sleep, 100
				this.win.wb.Evaluate("document.getElementById('" eid "').focus()")
				if (row - this.page_base = 1 && col = 1)
				{
					Sleep, 500
				}
				this.Send(row, col)
			}
		}
		; 마지막 입력 지워지지않게 input 박스의 포커스 없애기
		this.win.wb.Evaluate("document.getElementsByClassName('chargeArea')[0].click()")
		return true
	}
	AutoExchangeInput(row, code)
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('inDetailBox')[0].getElementsByTagName('IMG').length")
		length := result.value
		if (length < 1)
		{
			this.SetInputElementsError()
			return false
		}
		bFound := false
		
		Loop, %length%
		{
			result := this.win.wb.Evaluate("document.getElementsByClassName('inDetailBox')[0].getElementsByTagName('IMG')[" A_Index - 1 "].alt")
			if (result.value = this.issued_company)
			{
				this.win.wb.Evaluate("document.getElementsByClassName('inDetailBox')[0].getElementsByTagName('IMG')[" A_Index - 1 "].click()")
				bFound := true
				break
			}
		}
		if (!bFound)
		{
			this.err := "입력페이지에서 " this.issued_company " 요소를 찾을수 없습니다."
			return false
		}
		if (this.issued_company = "기프티콘")
		{
			this.win.wb.Evaluate("document.getElementById('phoneNo').focus()")
			Send, % this.phone_number
			this.win.wb.Evaluate("document.getElementById('agreeThisOne').click()")
		}
		this.win.wb.Evaluate("document.getElementById('couponNo').focus()")
		this.SendExchange(row, code)
		this.win.wb.Evaluate("document.getElementById('couponRetrieve').click()")
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}
		result := this.win.wb.Evaluate("escape(document.getElementsByClassName('payDetail excCoupon')[2].innerText)")  
		result_msg := _app.dlgSetting.StrUnescape(result.value)
		
		if (RegExMatch(result_msg, "가능합니다"))
		{
			charge_btnclass := _app.setting.ex_charging_target ? "hpOnlin" : "hpCash"
			this.win.wb.Evaluate("document.getElementsByClassName('" charge_btnclass "')[0].getElementsByTagName('A')[0].click()")
			result := this.win.wb.Evaluate("escape(document.getElementsByClassName('payDetail excCoupon')[2].innerText)")  
			result_msg := _app.dlgSetting.StrUnescape(result.value)
			if (RegExMatch(result_msg, "충전되었습니다|완료되었습니다"))
			{
				_app.editLog.AppendText(result.value "`r`n")
				return true
			}
			return this.ConfirmExchangeErrorGoNext(row)
		}
		else
		{
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}
}
class CBookNLifeIE extends CBookNLife
{
	__New()
	{
		base.__New(0)
	}
	IsLogined()
	{
		elm := this.win.wb.document.getElementById("btn_logoutTOP")
		return (elm && elm.tagName)
	}
	AutoExchangeInput(row, code)
	{
		elements := this.win.wb.document.getElementsByClassName("tabList01 num04")
		if (!elements || elements.length < 1)
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.document.getElementById("couponNum").focus()
		this.SendExchange(row, code)
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}		
		index := _app.setting.ex_charging_target ? 1 : 0
		Sleep, 200
		this.win.wb.document.getElementsByClassName("btnLWhite Btn_chstyle2")[index].click()
		Sleep, 500
		if (!this.win.WaitComplete())
		{
			this.err := "충전 완료페이지로 이동에 실패했습니다"
			return false
		}
		Sleep, 500
		result_msg := document.getElementsByClassName("boardList")[0].innerText
		if (RegExMatch(result_msg, "O)쿠폰교환(.*)원[\d\-]+정상적으로", matches))
			{
			result := matches[1]
			if (index = 0)
			{
				success_msg := "북앤라이프 캐시 " result "원으로 정상적으로 교환되었습니다."
			}
			else
			{
				success_msg := "북앤라이프 상품권 " SubStr(result, 1, 19) "-" SubStr(result, 20, 4) " 으로 정상적으로 교환되었습니다."
			}
			_app.editLog.AppendText(success_msg "`r`n")
			return true
		}
		else
		{
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}
	AutoInput()
	{
		elements := this.win.wb.document.getElementsByClassName("btnLnit")
		if (!elements)
		{
			this.SetInputElementsError()
			return false
		}
		if (elements.length = 1)
		{
			elements[0].click()
			elements[0].scrollIntoView(true)
		}
		if (this.codes.MaxIndex() - this.page_base > 5)
		{
			elements := this.win.wb.document.getElementsByClassName("btnPlus")
			if (elements.length = 1)
			{
				Loop, % (this.codes.MaxIndex() - this.page_base - 5)
				{
					elements[0].click()
				}
			}
		}
		cols := Array()
		Loop, 4
		{
			cols[A_Index] := this.win.wb.document.getElementsByClassName("pinno" A_Index)
		}
		cols[5] := this.win.wb.document.getElementsByClassName("pincode")
		
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				cols[col][row - this.page_base -1].innerText := this.codes[row][col]
				this.Send(row, col, true)
			}
		}
		return true
	}
}
class CBookNLifeCR extends CBookNLife
{
	__New()
	{
		base.__New(1)
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("document.getElementById('btn_logoutTOP')")
		return (result.subtype != "null")
	}
	AutoExchangeInput(row, code)
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('tabList01 num04').length")
		if (result.value != 1)
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.Evaluate("document.getElementById('couponNum').focus()")
		this.SendExchange(row, code)
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}		
		index := _app.setting.ex_charging_target ? 1 : 0
		Sleep, 200
		this.win.wb.Evaluate("document.getElementsByClassName('btnLWhite Btn_chstyle2')[" index "].click()")
		Sleep, 500
		if (!this.win.WaitComplete())
		{
			this.err := "충전 완료페이지로 이동에 실패했습니다"
			return false
		}
		Loop, 20
		{
			Sleep, 200
			result := this.win.wb.Evaluate("document.getElementsByClassName('boardList').length")  
			if (result && result.value > 0)
			{
				break
			}
		}
		result := this.win.wb.Evaluate("escape(document.getElementsByClassName('boardList')[0].innerText)")  
		result_msg := _app.dlgSetting.StrUnescape(result.value)
		if (RegExMatch(result_msg, "O)쿠폰교환(.*)원[\d\-]+정상적으로", matches))
		{
			result := matches[1]
			if (index = 0)
			{
				success_msg := "북앤라이프 캐시 " result "원으로 정상적으로 교환되었습니다."
			}
			else
			{
				success_msg := "북앤라이프 상품권 " SubStr(result, 1, 19) "-" SubStr(result, 20, 4) " 으로 정상적으로 교환되었습니다."
			}
			_app.editLog.AppendText(success_msg "`r`n")
			return true
		}
		else
		{
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}	
	AutoInput()
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('btnLnit').length")
		if (result.value != 1)
		{
			this.SetInputElementsError()
			return false
		}
		
		this.win.wb.Evaluate("document.getElementsByClassName('btnLnit')[0].click()")
		this.win.wb.Evaluate("document.getElementsByClassName('btnLnit')[0].scrollIntoView(true)")
		
		if (this.codes.MaxIndex() - this.page_base > 5)
		{
			Loop, % (this.codes.MaxIndex() - this.page_base - 5)
			{
				this.win.wb.Evaluate("document.getElementsByClassName('btnPlus')[0].click()")
			}
		}
		
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				if (col = 5)
				{
					this.win.wb.Evaluate("document.getElementsByClassName('pincode')[" (row - this.page_base - 1) "].focus()")
				}
				else
				{
					this.win.wb.Evaluate("document.getElementsByClassName('pinno" col "')[" (row - this.page_base - 1)"].focus()")
				}
				this.Send(row, col)
			}
		}
		return true
	}
}
class CCultureLandIE extends CCultureLand
{
	__New()
	{
		base.__New(0)
	}
	IsLogined()
	{
		elm := this.win.wb.document.getElementsByClassName("cta login")
		return (elm && elm.length = 1)
	}
	AutoInput()
	{
		elements := this.win.wb.document.getElementsByClassName("stock-open")
		if (!elements || elements.length != 1)
		{
			this.SetInputElementsError()
			return false
		}
		if (this.codes.MaxIndex() - this.page_base > 5)
		{
			if (elements[0].style.display != "none")
			{
				elements[0].click()
			}
		}
		elements := this.win.wb.document.getElementsByClassName("sub-visual")
		if (elments && elements.length = 1)
		{
			elements[0].scrollIntoView(true)
			Sleep, 200
		}
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				eid := "scr" (row - this.page_base) col
				this.win.wb.document.getElementById(eid).click()
				this.Send(row, col)
			}
		}
		return true
	}
}
class CCultureLandCR extends CCultureLand
{
	__New()
	{
		base.__New(1)
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('cta login').length")
		return (result.value = 1)
	}
	AutoInput()
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('stock-open').length")
		if (result.value != 1)
		{
			this.SetInputElementsError()
			return false
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('sub-visual')[0].scrollIntoView(true)")
		Sleep, 200
		if (this.codes.MaxIndex() - this.page_base> 5)
		{
			result := this.win.wb.Evaluate("document.getElementsByClassName('stock-open')[0].style.display")
			if (result.value != "none")
			{
				result := this.win.wb.Evaluate("document.getElementsByClassName('stock-open')[0].click()")
				Sleep, 500
			}
		}
		; autoTab2 끄기. 안끄면 Send로 보낸 4번째 숫자가 씹힘.
		disable_autotab := "function autoTab2(obj, className, event){}"
		result := this.win.wb.Evaluate(disable_autotab)
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				eid := "scr" (row - this.page_base) col
				this.win.wb.Evaluate("document.getElementById('" eid "').focus()")
				if ((row - this.page_base) = 1 && col = 1)
				{
					Sleep, 200
				}
				this.Send(row, col)
				Sleep, % _app.setting.send_interval
			}
		}
		return true
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Chrome 지원용 클래스들
;; 설정에서 익스플로러를 선택하면 아래 크롬 관련 클래스들은 호출 안됨.
class CHTTP
{
	__New()
	{
		this.http := ComObjCreate("WinHttp.WinHttpRequest.5.1")
	}
	__Delete()
	{
		if (this.http)
		{
			ObjRelease(this.http)
		}
	}
	Get(url)
	{
		try
		{
			this.http.open("GET", url, False)
			this.http.setRequestHeader("Cache-Control", "max-age=0")
			this.http.Send()
			return this.http.responseText
		}
		catch e
		{
		}
		return ""
	}
}
class CChrome
{
	__New()
	{
		this.port := 9222
	}
	Launch(port := 9222)
	{
		RegRead, path, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\chrome.exe
		if (!path)
		{
			FileGetShortcut, %A_StartMenuCommon%\Programs\Chrome.lnk, path
			if (!path)
			{
				FileGetShortcut, %A_StartMenu%\Programs\Chrome.lnk, path
			}
		}
		if (FileExist(path))
		{
			this.path := path
		}
		else
		{
			MsgBox, , Chrome Error, "설치된 크롬경로를 찾을수 없습니다"
			return
		}
		target := this.path " --remote-debugging-port=" port " --user-data-dir=""" A_ScriptDir "\chromeprofile_autocoder"""
		Run, %target%
		this.port := port
		Loop, 10
		{
			Sleep, 200
			if (this.IsExist())
			{
				break
			}
		}
	}
	IsExist()
	{
		for proc in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process where name='chrome.exe'")
		{
			if (InStr(proc.CommandLine, "--remote-debugging-port=" this.port " --user-data-dir"))
			{
				return WinExist("ahk_pid " proc.ProcessId)
			}
		}
		return false
	}
	GetWebSocketUrl(title)
	{
		; 크롬 디버거용 로컬서버에서 디버깅주소가져오기임. 모두 로컬주소로 외부서버로 나가는 일 없음
		http := new CHTTP()
		list := JSON.Load(http.Get("http://127.0.0.1:" this.port "/json/list"))
		if (!list)
		{
			return -1
		}
		Loop, % list.MaxIndex()
		{
			if (list[A_Index].title = title)
			{
				return list[A_Index].webSocketDebuggerUrl
			}
		}
		return ""
	}
}
class CWebSocket extends CWindow
{
	; 크롬 로컬 디버거 서버랑 WebSocket통신을 하기위한 용도로 익스플로러 ActiveX를 하는 호스팅하는 것임
	; 데이터교환흐름 AHK자동입력기<->익스플로러 로컬페이지<->크롬 로컬디버거서버
	__New(url)
	{
		this.url := url
		static wb
		Gui, WebSocket:+Owner1 +hWndhWnd
		Gui, WebSocket:Add, ActiveX, vwb, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=edge'>
		base.__New(hWnd)
		html =
(
<script>
var ws = null;
function Init(url)
{
	ws = new WebSocket(url);
	ws.onopen = EventHandler;
	ws.onclose = EventHandler;
	ws.onerror = EventHandler;
	ws.onmessage = EventHandler;
}
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e);
	}
}
</script>
)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		this.ie.Init(url)
	}
	__Delete()
	{
		this.ie := ""
		this.wb := ""
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	Send(data)
	{
		this.ie.ws.send(data)
	}
	Close(code:=1000, reason:="")
	{
		this.ie.ws.close(code, reason)
	}
	Destroy()
	{
		this.ie._EventHandler := ""
		Gui, WebSocket:Destroy
	}	
}
class CChromeWSClient extends CWebSocket
{
	__New(url)
	{
		this.boolean_false := {boolean : false}
		this.boolean_true := {boolean : true}
		this.bConnected := false
		this.responses := Array()
		this.fnPing := this.Ping.Bind(this)
		base.__New(url)
		Loop, 20
		{
			if (this.bConnected)
			{
				break
			}
			Sleep, 50
		}
	}
	__Delete()
	{
		base.__Delete()
	}
	Call(method, params:="", bWait := true)
	{
		if (!this.bConnected)
		{
			return ""
		}
		id := 1
		if (this.responses.MaxIndex())
		{
			id := this.responses.MaxIndex() + 1
		}
		data := Object()
		data.id := id
		data.method := method
		data.params := params
		datastr := StrReplace(StrReplace(JSON.Dump(data), "{""boolean"":0}", "false"), "{""boolean"":1}", "true")
		this.Send(datastr)
		if (!bWait)
		{
			return
		}
		this.responses[id] := false
		Loop, 100
		{
			if (this.responses[id])
				break
			sleep, 50
		}
		response := this.responses.Delete(id)
		if (response)
		{
			if (response.error)
			{
			}
			return response.result
		}
		return ""
	}
	Navigate(url)
	{
		params := {}
		params.url := url
		response := this.Call("Page.navigate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.frameId
		
	}
	Evaluate(expression)
	{
		params := {}
		params.expression := expression
		params.objectGroup := "console"
		params.includeCommandLineAPI := this.boolean_true
		params.silent := this.boolean_false
		params.returnByValue := this.boolean_false
		params.userGesture := this.boolean_true
		params.awaitPromise := this.boolean_false
		response := this.Call("Runtime.evaluate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.result
	}
	Ping()
	{
		this.Call("Browser.getVersion", "",false)
	}
	GetVersion()
	{
		return this.Call("Browser.getVersion")
	}
	OnOpen(e)
	{
		this.bConnected := true
		ping := this.fnPing
		SetTimer, %ping%, 15000
	}
	OnMessage(e)
	{
		data := JSON.Load(e.data)
		if (this.responses.HasKey(data.id))
		{
			this.responses[data.id] := data
		}
	}
	OnClose(e)
	{
		this.Destroy()
		this.bConnected := false
		ping := this.fnPing
		SetTimer, %ping%,  Delete
		; 반드시 지워야 클래스오브젝트가 릴리스됨.
		this.fnPing := ""
		this.ie.ws := ""
		_app.PostMessage(_app.WM_WEBSOCKET_DISCONNECTED, 0, 0)
	}
	OnError(e)
	{

	}
	Disconnect()
	{
		if (this.bConnected)
			base.Close()
		Loop, 20
		{
			if (!this.bConnected)
				break
			Sleep, 50
		}
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 이하는 외부의 공개 WBGet함수, JSON 라이브러리 코드입니다. 
;; 자동입력기를 하나의 파일로 배포하기 위해 따로 Include하지 않고 
;; 원본소스에서 주석, 공백제거한후 코드에 이어 삽입했습니다.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; [WBGet function for AHK v1.1]
; WBGet function - AutoHotkey Community
; https://autohotkey.com/boards/viewtopic.php?f=6&t=39869
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WBGet(WinTitle="ahk_class IEFrame", Svr#=1) {               ;// based on ComObjQuery docs
   static msg := DllCall("RegisterWindowMessage", "str", "WM_HTML_GETOBJECT")
        , IID := "{0002DF05-0000-0000-C000-000000000046}"   ;// IID_IWebBrowserApp
;//     , IID := "{332C4427-26CB-11D0-B483-00C04FD90119}"   ;// IID_IHTMLWindow2
   SendMessage msg, 0, 0, Internet Explorer_Server%Svr#%, %WinTitle%
   if (ErrorLevel != "FAIL") {
      lResult:=ErrorLevel, VarSetCapacity(GUID,16,0)
      if DllCall("ole32\CLSIDFromString", "wstr","{332C4425-26CB-11D0-B483-00C04FD90119}", "ptr",&GUID) >= 0 {
         DllCall("oleacc\ObjectFromLresult", "ptr",lResult, "ptr",&GUID, "ptr",0, "ptr*",pdoc)
         return ComObj(9,ComObjQuery(pdoc,IID,IID),1), ObjRelease(pdoc)
      }
   }
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; JSON lib for AutoHotkey v2.1.3 [updated 04/18/2016 (MM/DD/YYYY)]
; 배포사이트 : https://github.com/cocobelgica/AutoHotkey-JSON
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class JSON
{
class Load extends JSON.Functor
{
Call(self, ByRef text, reviver:="")
{
this.rev := IsObject(reviver) ? reviver : false
this.keys := this.rev ? {} : false
static quot := Chr(34), bashq := "\" . quot
, json_value := quot . "{[01234567890-tfn"
, json_value_or_array_closing := quot . "{[]01234567890-tfn"
, object_key_or_object_closing := quot . "}"
key := ""
is_key := false
root := {}
stack := [root]
next := json_value
pos := 0
while ((ch := SubStr(text, ++pos, 1)) != "") {
if InStr(" `t`r`n", ch)
continue
if !InStr(next, ch, 1)
this.ParseError(next, text, pos)
holder := stack[1]
is_array := holder.IsArray
if InStr(",:", ch) {
next := (is_key := !is_array && ch == ",") ? quot : json_value
} else if InStr("}]", ch) {
ObjRemoveAt(stack, 1)
next := stack[1]==root ? "" : stack[1].IsArray ? ",]" : ",}"
} else {
if InStr("{[", ch) {
static json_array := Func("Array").IsBuiltIn || ![].IsArray ? {IsArray: true} : 0
(ch == "{")
? ( is_key := true
, value := {}
, next := object_key_or_object_closing )
: ( value := json_array ? new json_array : []
, next := json_value_or_array_closing )
ObjInsertAt(stack, 1, value)
if (this.keys)
this.keys[value] := []
} else {
if (ch == quot) {
i := pos
while (i := InStr(text, quot,, i+1)) {
value := StrReplace(SubStr(text, pos+1, i-pos-1), "\\", "\u005c")
static tail := A_AhkVersion<"2" ? 0 : -1
if (SubStr(value, tail) != "\")
break
}if (!i)
this.ParseError("'", text, pos)
  value := StrReplace(value,  "\/",  "/")
, value := StrReplace(value, bashq, quot)
, value := StrReplace(value,  "\b", "`b")
, value := StrReplace(value,  "\f", "`f")
, value := StrReplace(value,  "\n", "`n")
, value := StrReplace(value,  "\r", "`r")
, value := StrReplace(value,  "", "`t")
pos := i
i := 0
while (i := InStr(value, "\",, i+1)) {
if !(SubStr(value, i+1, 1) == "u")
this.ParseError("\", text, pos - StrLen(SubStr(value, i+1)))
uffff := Abs("0x" . SubStr(value, i+2, 4))
if (A_IsUnicode || uffff < 0x100)
value := SubStr(value, 1, i-1) . Chr(uffff) . SubStr(value, i+6)
}if (is_key) {
key := value, next := ":"
continue
}} else {
value := SubStr(text, pos, i := RegExMatch(text, "[\]\},\s]|$",, pos)-pos)
static number := "number", integer :="integer"
if value is %number%
{
if value is %integer%
value += 0
}else if (value == "true" || value == "false")
value := %value% + 0
else if (value == "null")
value := ""
else
this.ParseError(next, text, pos, i)
pos += i-1
}next := holder==root ? "" : is_array ? ",]" : ",}"
}is_array? key := ObjPush(holder, value) : holder[key] := value
if (this.keys && this.keys.HasKey(holder))
this.keys[holder].Push(key)
}}
return this.rev ? this.Walk(root, "") : root[""]
}ParseError(expect, ByRef text, pos, len:=1)
{
static quot := Chr(34), qurly := quot . "}"
line := StrSplit(SubStr(text, 1, pos), "`n", "`r").Length()
col := pos - InStr(text, "`n",, -(StrLen(text)-pos+1))
msg := Format("{1}`n`nLine:`t{2}`nCol:`t{3}`nChar:`t{4}"
,     (expect == "")     ? "Extra data"
: (expect == "'")    ? "Unterminated string starting at"
: (expect == "\")    ? "Invalid \escape"
: (expect == ":")    ? "Expecting ':' delimiter"
: (expect == quot)   ? "Expecting object key enclosed in double quotes"
: (expect == qurly)  ? "Expecting object key enclosed in double quotes or object closing '}'"
: (expect == ",}")   ? "Expecting ',' delimiter or object closing '}'"
: (expect == ",]")   ? "Expecting ',' delimiter or array closing ']'"
: InStr(expect, "]") ? "Expecting JSON value or array closing ']'"
:                      "Expecting JSON value(string, number, true, false, null, object or array)"
, line, col, pos)
static offset := A_AhkVersion<"2" ? -3 : -4
throw Exception(msg, offset, SubStr(text, pos, len))
}Walk(holder, key)
{
value := holder[key]
if IsObject(value) {
for i, k in this.keys[value] {
v := this.Walk(value, k)
if (v != JSON.Undefined)
value[k] := v
else
ObjDelete(value, k)
}}
return this.rev.Call(holder, key, value)
}}
class Dump extends JSON.Functor
{
Call(self, value, replacer:="", space:="")
{
this.rep := IsObject(replacer) ? replacer : ""
this.gap := ""
if (space) {
static integer := "integer"
if space is %integer%
Loop, % ((n := Abs(space))>10 ? 10 : n)
this.gap .= " "
else
this.gap := SubStr(space, 1, 10)
this.indent := "`n"
}return this.Str({"": value}, "")
}Str(holder, key)
{
value := holder[key]
if (this.rep)
value := this.rep.Call(holder, key, ObjHasKey(holder, key) ? value : JSON.Undefined)
if IsObject(value) {
static type := A_AhkVersion<"2" ? "" : Func("Type")
if (type ? type.Call(value) == "Object" : ObjGetCapacity(value) != "") {
if (this.gap) {
stepback := this.indent
this.indent .= this.gap
}is_array := value.IsArray
if (!is_array) {
for i in value
is_array := i == A_Index
until !is_array
}str := ""
if (is_array) {
Loop, % value.Length() {
if (this.gap)
str .= this.indent
v := this.Str(value, A_Index)
str .= (v != "") ? v . "," : "null,"
}} else {
colon := this.gap ? ": " : ":"
for k in value {
v := this.Str(value, k)
if (v != "") {
if (this.gap)
str .= this.indent
str .= this.Quote(k) . colon . v . ","
}}
}if (str != "") {
str := RTrim(str, ",")
if (this.gap)
str .= stepback
}if (this.gap)
this.indent := stepback
return is_array ? "[" . str . "]" : "{" . str . "}"
}} else
return ObjGetCapacity([value], 1)=="" ? value : this.Quote(value)
}Quote(string)
{
static quot := Chr(34), bashq := "\" . quot
if (string != "") {
  string := StrReplace(string,  "\",  "\\")
, string := StrReplace(string, quot, bashq)
, string := StrReplace(string, "`b",  "\b")
, string := StrReplace(string, "`f",  "\f")
, string := StrReplace(string, "`n",  "\n")
, string := StrReplace(string, "`r",  "\r")
, string := StrReplace(string, "`t",  "")
static rx_escapable := A_AhkVersion<"2" ? "O)[^\x20-\x7e]" : "[^\x20-\x7e]"
while RegExMatch(string, rx_escapable, m)
string := StrReplace(string, m.Value, Format("\u{1:04x}", Ord(m.Value)))
}return quot . string . quot
}}
Undefined[]
{
get {
static empty := {}, vt_empty := ComObject(0, &empty, 1)
return vt_empty
}}
class Functor
{
__Call(method, ByRef arg, args*)
{
if IsObject(method)
return (new this).Call(method, arg, args*)
else if (method == "")
return (new this).Call(arg, args*)
}}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
